#include <stdio.h>
#include <stdlib.h>
#include "stablo.h"

int br_el_na_nivou(cvor *s, int nivo) {
	//broj elemenata na nivo k je
	
	//broj elemenata na nivou k-1 levog podstabla
	// + broj elemenata na nivou k-1 desnog podstabla
	
	if(s == NULL)
		return 0;
	
	//nivo racunamo od 0, tako da 
	//ovde proveravamo da li je nivo jednak 0
	if(nivo == 0)
		return 1;
	
	return br_el_na_nivou(s->levo, nivo - 1) 
		+ br_el_na_nivou(s->desno, nivo - 1);
}

int br_el_razlika(cvor *s) {
	if(s == NULL)
		return 0;
	
	int rezultat = 0;
	//ako proveravamo razliku naslednika
	//naslednici moraju da postoje!!!
	if(s->levo != NULL && s->desno != NULL)
		if(s->vrednost == 
			s->desno->vrednost - s->levo->vrednost)
			rezultat = rezultat + 1;
	
	return rezultat +
		br_el_razlika(s->levo) +
		br_el_razlika(s->desno);
}

void rotiraj(cvor *koren) {
	if(koren == NULL)
		return;
	
	cvor *temp = koren->levo;
	koren->levo = koren->desno;
	koren->desno = temp;
	
	rotiraj(koren->levo);
	rotiraj(koren->desno);
}

int main() {
	cvor *s = ucitaj_stablo();
	ispis_LKD(s);
	
	//1.
	int nivo;
	scanf("%d", &nivo);
	printf("broj el na nivou: %d\n", 
		br_el_na_nivou(s, nivo));
	
	//2.
	printf("broj el razlika: %d\n", 
		br_el_razlika(s));
	
	//4.
	rotiraj(s);
	ispis_LKD(s);
	
	s = oslobodi(s);
}